viDraw = {};

function viDraw:setOpen()
	VehicleInspector.clickAreas.slave["default"] = {};
	VehicleInspector.clickAreas.master["default"] = {};
	--if VehicleInspector.global.foundMoh and VehicleInspector.global.onlyMoh then VehicleInspector.isVisible=false;return;end;
	if not viSetGet:helpMenue() or not viSetGet:inGameMapMenu() then VehicleInspector.isVisible=false;return;end;
	viOutput:loadVehicle(true,false);
	if VehicleInspector.output == nil or #VehicleInspector.output <= 0 then VehicleInspector.isVisible=false;return;end;
	VehicleInspector.isVisible = true;
	local posX = VehicleInspector.global.posX[VehicleInspector.global.viewModus];
	local posY = VehicleInspector.global.posY[VehicleInspector.global.viewModus];
	local width = 0; --VehicleInspector.global.width[VehicleInspector.global.viewModus];
	local height = 0; --VehicleInspector.global.height[VehicleInspector.global.viewModus];
	--local lastWidth = VehicleInspector.global.width.last;
	--local lastHeight = VehicleInspector.global.height.last;
	local endPosY = g_currentMission.hlGui.menue.posY[2]+g_currentMission.hlGui.menue.height[2];
	local txtSize = VehicleInspector.global.txtSize;
	local txtHeight = getTextHeight(txtSize, utf8Substr("Äg", 0));
	local txtWidthDistance = VehicleInspector.global.txtWidthDistance;
	local txtLineDistance = VehicleInspector.global.txtLineDistance;	
	local separatorColor = g_currentMission.hl.getColor(VehicleInspector.showColor.separator, true);
	local txt = "";
	local isToLarge = false;
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	if VehicleInspector.global.seeBackground then VehicleInspector.overlays["ground"]:render();end;
	
	local nextPosY = posY-txtHeight-(txtLineDistance);
	local nextPosX = posX;	
	for line=1, #VehicleInspector.output do
		local isLine = VehicleInspector.output[line];
		if isLine ~= nil and isLine.txt ~= nil and #isLine.txt > 0 then
			local txtWidth = 0;
			nextPosX = posX;
			for outputTxt=1, #isLine.txt do
				local isTxt = isLine.txt[outputTxt];				
				if isTxt ~= nil then
					setTextAlignment(0);
					if isTxt.separator then
						setTextColor(unpack(separatorColor));							
						setTextBold(false);
						renderText(nextPosX, nextPosY, txtSize, tostring(VehicleInspector.txt.separator));
						txtWidth = txtWidth+getTextWidth(txtSize, utf8Substr(VehicleInspector.txt.separator, 0))+txtWidthDistance;
					else
						txt = utf8Substr(isTxt.txt, 0);
						setTextColor(unpack(isTxt.txtColor));							
						setTextBold(isTxt.txtBold);
						renderText(nextPosX, nextPosY, txtSize, tostring(txt));					
						txtWidth = txtWidth+getTextWidth(txtSize, txt)+txtWidthDistance;
					end;					
					setTextAlignment(0);
					setTextColor(1, 1, 1, 1);
					setTextBold(false);
					nextPosX = posX+txtWidth;
				end;				
			end;			
			if width < txtWidth then width = txtWidth;end; --for background
			txt = "";
			if isLine.rootNode ~= nil and isLine.rootNode > 0 and not disableClickArea then viDraw:clickAreas(false, {posX, nextPosX, nextPosY, nextPosY+txtHeight+txtLineDistance, whereClick="vehicleJoin_", rootNode=isLine.rootNode} );end;
			if line ~= #VehicleInspector.output then nextPosY = nextPosY-txtHeight-txtLineDistance;end;
			if nextPosY-txtHeight-txtLineDistance < endPosY then isToLarge=true;break;end;
		end;
	end;	
	height = posY-nextPosY+txtLineDistance;			 
	VehicleInspector.global.width[VehicleInspector.global.viewModus] = width+0.002; 
	VehicleInspector.global.height[VehicleInspector.global.viewModus] = height;		
	if not disableClickArea then viDraw:clickAreas(true, {posX-0.001, posX-0.001+(width+0.002), nextPosY-txtLineDistance, nextPosY-txtLineDistance+height} );end;
	if VehicleInspector.global.seeBackground then
		if VehicleInspector.overlays["ground"].a ~= VehicleInspector.global.backgroundT then 
			local backgroundColor = g_currentMission.hl.getColor(VehicleInspector.showColor.background, true);
			backgroundColor[4] = VehicleInspector.global.backgroundT;
			VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["ground"], backgroundColor}, "viDraw:setOpen()");
		end;
		g_currentMission.hl.setOverlay(VehicleInspector.overlays["ground"], posX-0.001, nextPosY-txtLineDistance, width+0.002, height);
	end;
	if isToLarge and g_currentMission.hl.runsTimer("1sec", true) then
		setTextBold(true);
		setTextColor(unpack(g_currentMission.hl.getColor("ls22", true)));
		renderText(posX, nextPosY, txtSize, tostring("! to large !"));
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
	end;
end;

function viDraw:clickAreas(masterArea, args)		
	if masterArea then
		VehicleInspector.clickAreas.master["default"] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea="default";
		};
	else	
		VehicleInspector.clickAreas.slave["default"][#VehicleInspector.clickAreas.slave["default"]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = "default";
			whereClick = args.whereClick;
			rootNode = args.rootNode;
		};
	end;
end;